package com.brainoff { 
	
	import flash.display.MovieClip;
	import flash.text.TextField;
	public class worldkitAnnotation {
	    protected var main:worldkitMain;
	    protected var conf:worldkitConfig;
	    protected var rss:worldkitRSS;
	    protected var interact:worldkitInteraction;
	    protected var img:worldkitImages;
	
	    protected var mc:MovieClip;
	    protected var depth:Number;
	    protected var title:String;
	    protected var url:String;
	    protected var lat:Number;
	    protected var lon:Number;
	    protected var summary:String;
	    protected var cats:Array;
	    protected var id:String;
	    protected var photo:String;
	    protected var prevlat:Number;
	    protected var prevlon:Number;
	    protected var vector:String;
	    protected var vtype:String;
	    protected var datestring:String;
	    protected var date:Date;
	    protected var precompile:Boolean;
	    protected var enddate:Date;
	
	    public var present:Boolean;
	    public var activate:Boolean;
	
	    protected var clipname:String;
	    protected var textname:String;
	    protected var x:Number;
	    protected var y:Number;
	    protected var prevx:Number;
	    protected var prevy:Number;
	    protected var scale:Number;
	    protected var jsargs:String;
	    protected var color:Number;
	    protected var createdate:Date;
	
	    protected var initialplotcolor:Number;
	    protected var restingplotcolor:Number;
	    protected var activatecolor:Number;
	    protected var plotsize:Number;
	    protected var plotshape:String;
	    protected var icon:String;
	    protected var linecolor:Number;
	    protected var zoomto:Number;
	    protected var linealpha:Number;
	    protected var linethickness:Number;
	    protected var fillalpha:Number;
	    protected var window:String;
	    protected var rssicon:String;
	    protected var curralpha:Number;
	
	    protected var colorobj:Color;
	
	    public function worldkitAnnotation(main:worldkitMain, mc:MovieClip, depth:Number, title:String, url:String, lat:Number, lon:Number, summary:String, cats:Array, id:String, photo:String, prevlat:Number, prevlon:Number, vector:String, vtype:String, datestring:String, precompile:Boolean, enddate:String, rssicon:String) {
	
		this.main = main;
		this.mc = mc;
		
		conf = main.getConfig();
		rss = main.getRSS();
		interact = main.getInteract();
		img = main.getImages();
	
		this.depth = depth;
		this.title = title;
		this.url = url;
		this.lat = lat;
		this.lon = lon;
		this.summary = summary;
		this.cats = cats;
		this.id = id;
		this.photo = photo;
		this.prevlat = prevlat;
		this.prevlon = prevlon;
		this.vector = vector;
		this.vtype = vtype;
		this.datestring = datestring;
		this.date = new Date(worldkitUtil.parseDate(datestring));
		this.precompile = precompile;
		if (enddate != undefined) {
		    this.enddate = new Date(worldkitUtil.parseDate(enddate));
		} 
		this.rssicon = rssicon;
	
		present = true;
		activate = false;
	    
		setparams();
	
		if (this.precompile == undefined) {
		    clipname = this.depth + "point";
		    textname = this.depth + "pointtext";
		    mc.createEmptyMovieClip(clipname,this.depth);
		} else {
		    clipname = this.title;
		    textname = this.title + "text";
		}
	
		if (this.precompile) {
		    colorobj = new Color(mc[ this.clipname ]);
		}
	
		createdate = new Date();
		curralpha = 100;
		mc[this.clipname].annotation = this;
	    }
	
	    public function setparams():void {
		initialplotcolor = conf.getConfBySubject("initialplotcolor", this.cats);
		restingplotcolor = conf.getConfBySubject("restingplotcolor", this.cats);
		activatecolor = conf.getConfBySubject("activatecolor", this.cats);
		plotsize = conf.getConfBySubject("plotsize", this.cats);
		plotshape = conf.getConfBySubject("plotshape", this.cats);
		icon = conf.getMatchingSubject("icon", this.cats);
		linecolor = conf.getConfBySubject("linecolor", this.cats);
		zoomto = conf.getConfBySubject("zoomto", this.cats);
		linealpha = conf.getConfBySubject("linealpha", this.cats);
		linethickness = conf.getConfBySubject("linethickness", this.cats);
		fillalpha = conf.getConfBySubject("fillalpha", this.cats);
		window = conf.getConfBySubject("window", this.cats);
	}
	    public function plot():void {
		if  (precompile != true && conf.accuplot != true) {
		    /**/
		    //reset scaling for plot
		    /**/
		    mc.x = 0; mc.y = 0; mc.scaleX = 100; mc.scaleY = 100;
		}
	
		if (precompile != true) {
		    /**/
		    // Calculate positions
		    /**/
		    var a = new Array();
		    a = interact.geo2xy(lat,lon,true); x = a[0]; y = a[1];
		    if (x == undefined || y == undefined) { return; }    
		    if (conf.track && prevlat != undefined && prevlon != undefined) { 
			a = interact.geo2xy(prevlat,prevlon); prevx = a[0]; prevy = a[1]; 
		    }
		    mc[clipname].x = x; mc[clipname].y = this.y;
	
		    var rescale = 100/interact.scale; 
		    scale = rescale;
		    if (vector == undefined && precompile != true && conf.accuplot != true) {
			mc[clipname].scaleX = rescale;    
			mc[clipname].scaleY = rescale;
		    } else if (conf.accuplot == true) {
			scale = 100 * 100 /conf.h;
			mc[clipname].scaleX = scale;
			mc[clipname].scaleY = scale;
		    }
		}
	
		jsargs = buildJsArgs();
	
		makeText();
	
		mc[clipname].onRelease = function() { this.annotation.onRelease(); }
		mc[clipname].onRollOver = function() { this.annotation.onRollOver();}
		mc[clipname].onRollOut = function() { this.annotation.onRollOut(); }
	
		setVisible(true,conf.textinterval);
	      
		shape(1);
	 
		if (initialplotcolor != restingplotcolor) { 
		    worldkitUtil.setTimeout(this, "shape", 60000, 2);
		}
	
		if (precompile != true && conf.accuplot != true) {
		    interact.scaleAndPosition(mc,undefined);
		}
	
	
		if (conf.newitemcallback) {
		    var msg = "title=" + escape(title) + "&url=" + escape(url) +  "&summary=" + escape( summary.split("\"").join("\\\"") ) +  "&lat=" + escape(String(lat)) + "&lon=" + escape(String(lon)) + "&id=" + escape(id);	
		    interact.processClick("", "_" + conf.newitemcallback, msg);
		}
	    }
	
	    public function makeText():void {
		if (conf.singletextfield != true) {
		    mc.createEmptyMovieClip(textname, depth+10000); //REVISIT places 10000 plot limit 
		    mc[ textname ].annotation = this;
		    mc[ textname ].visible = 0;
	
		    var w = mc.origwidth; var h = mc.origheight;
		    var textx = x; var texty = y;
		    var rescale = (100/interact.scale); 
		    var textboxsize = conf.textboxsize;
		    if (precompile) {
			rescale = rescale * (w/conf.h);
			textboxsize = textboxsize * (100/conf.h);
		    }
		    // should maybe try to position this to the right of the point, or dynamically dependent on zoom)
		    if (w - x < textboxsize) { textx = x - (textboxsize / interact.scale); }
		    if (h - y < 100) { texty = y - (50 / interact.scale); }	
	
		    mc[ textname ].x = textx; if (textx != x) { mc[textname].leftpos = true; }
		    mc[ textname ].y = texty; if (texty != y) { mc[textname].bottompos = true; }
	
	
		    mc[textname].scaleX = scale;    
		    mc[textname].scaleY = scale;
		
		    if (photo != "" && photo != undefined) {
			mc[textname].createEmptyMovieClip("image",100000); //REVISIT 100000
			mc[textname].image.loadMovie(photo);
		    } else {
			var htmlText = "<font color=\"#555555\" face=\"Verdana,Arial,_sans\" size=\"" + conf.textsize + "\"><b>" + title + "</b><br>" + summary + "</font>";
			var textheight = 100;
			if (conf.textboxsize != 0) {
			    mc[textname].text = new TextField();
			    mc[textname].addChildAt(mc[textname].text, 1);
			    mc[textname].text.width = textboxsize;
			    mc[textname].text.height = textheight;
			    
			    mc[textname].text.html = true; //REVISIT this might be trouble with non-roman chars
			    mc[textname].text.multiline = true;
			    mc[textname].text.wordWrap = true;
			    mc[textname].text.border = true;
			    mc[textname].text.autoSize ="center";
			    mc[textname].text.background = true;
			    mc[textname].text.backgroundColor = 0xFFFFFF;		
			    mc[textname].text.htmlText = htmlText;
			}
		    }
	
		    mc[textname].onRelease = function() { this.annotation.onReleaseText(); }
		}
	
	    }
	
	    protected function shape(time:Number):void {
		if (mc[clipname] == undefined) { return; }
	
		mc[clipname].graphics.clear();
	
		if (time == 3) { color = activatecolor; }
		else if (time == 1) { color = initialplotcolor; }
		else { color = restingplotcolor; }
	 
		if (precompile == true) {
		    colorobj.setRGB( color );
		} else if (vtype == "poly") {
		    drawpoly();
		} else if (vtype == "line") {
		    drawline();
		} else if (vtype == "box") {
		    drawbox();
		} else if (rssicon != undefined && rssicon != "") {
		    if (time == 1) {
			loadrssicon();
		    } else {
			activateicon(time);
		    }
		} else if (icon != undefined && icon != "") {
		    if (time == 1) {
			loadicon();
		    } 
		} else if (plotshape == "square") {
		    square();
		} else if (plotshape == "circle") {
		    circle();
		} else if (plotshape == "triangle") {
		    triangle();
		} 
		
		tracks();
	
	    }
	
	    protected function drawpoly():void {
		var polyarray = vector.split(" ");
		var xy,x,y;
	
		mc[clipname].graphics.lineStyle( linethickness, linecolor, linealpha);
		for (var i=0; i<polyarray.length-1; i+=2) {
		    xy = interact.geo2xy(polyarray[i],polyarray[i+1]);
		    x = xy[0] - mc[clipname].x; //need to adjust geo2xy
		    y = xy[1] - mc[clipname].y; //relative to movie clip position
		    if (i == 0) {
			mc[clipname].graphics.moveTo(x,y);
			mc[clipname].graphics.beginFill( color, fillalpha );
		    } else {
			mc[clipname].graphics.lineTo(x,y);
		    }
		}
		mc[clipname].graphics.endFill();
	    }
	
	    protected function drawbox():void {
		var boxarray = vector.split(" ");
		if (boxarray.length == 4) {
		    vector = boxarray[0] + " " + boxarray[1] + " " + boxarray[0] + " " + boxarray[3] + " " + boxarray[2] + " " + boxarray[3] + " " + boxarray[2] + " " + boxarray[1] + " " + boxarray[0] + " " + boxarray[1];
		    vtype = "poly";
		    drawpoly();
		}
	    }
	
	    protected function drawline():void {
		var linearray = vector.split(" ");
		var l;
		var xy,x,y;
	
		mc[clipname].graphics.lineStyle( linethickness, linecolor, linealpha); 
		for (var i=0; i<linearray.length-1; i+=2) {
		    xy = interact.geo2xy(linearray[i],linearray[i+1]);
		    x = xy[0]  - mc[clipname].x; //need to adjust geo2xy
		    y = xy[1]  - mc[clipname].y; //relative to movie clip position
		    if (i == 0) {
			mc[clipname].graphics.moveTo(x,y);
		    } else {
			mc[clipname].graphics.lineTo(x,y);
		    }
		}
	    }
	    
	    protected function square():void {
		var x = 0; var y = 0; //movie clip is already positioned
		var s = plotsize;
		mc[clipname].graphics.lineStyle( linethickness, linecolor, linealpha );
		mc[clipname].graphics.moveTo(x-s,y-s);
		mc[clipname].graphics.beginFill( color, fillalpha );
		mc[clipname].graphics.lineTo(x-s,y+s);
		mc[clipname].graphics.lineTo(x+s,y+s);
		mc[clipname].graphics.lineTo(x+s,y-s);
		mc[clipname].graphics.lineTo(x-s,y-s);
		mc[clipname].graphics.endFill();	
	    }
	
	    protected function circle():void {
		var x = 0; var y = 0; //movie clip is already positioned
		var s = plotsize;
		mc[clipname].graphics.lineStyle( linethickness, linecolor, linealpha );
		mc[clipname].graphics.moveTo(x+s,y); //move to point on the circle to drawArc
		mc[clipname].graphics.beginFill( color, fillalpha );
		mc[clipname].drawArc(x+s,y,s,360,0);
		mc[clipname].graphics.endFill();	
	    }
	
	    protected function triangle():void {
		var x = 0; var y = 0; //movie clip is already positioned
		var s = plotsize;
		mc[clipname].graphics.lineStyle( linethickness, linecolor, linealpha );
		mc[clipname].graphics.moveTo(x /*Math.cos(Math.PI / 2)*/,
				    y - s /*Math.sin(Math.PI / 2)*/);
		mc[clipname].graphics.beginFill( color );
		//this.datalayer[this.clipname].graphics.lineTo(x + s * -0.86603 /*Math.cos(Math.PI * 7 / 6)*/,
		//		      y - s * -0.5 /*Math.sin(Math.PI * 7 / 6)*/ );
		//this.datalayer[this.clipname].graphics.lineTo(x - s * 0.86603 /*Math.cos(Math.PI * 11 / 6)*/,
		//		      y - s * -0.5 /*Math.sin(Math.PI * 11 / 6)*/ );
		mc[clipname].graphics.lineTo(x+s,y+s);
		mc[clipname].graphics.lineTo(x-s,y+s);
		mc[clipname].graphics.lineTo(x,y - s);
		mc[clipname].graphics.endFill();
	    }
		
	    //REVISIT if icon hasn't loaded yet, it won't load here
	    protected function loadicon():void {
		if (mc[clipname]["icon"] == undefined) {
		    mc[clipname].createEmptyMovieClip("icon",1);
		} 
		if (! img.loadicon(mc[clipname]["icon"], "icon" + icon)) {
		    worldkitUtil.setTimeout(this, "loadicon", 1000);
		}
	    }
	
	    protected function loadrssicon():void {
		if (mc[clipname]["icon"] == undefined) {
			mc[clipname].createEmptyMovieClip("icon",1);
		}
		if (! img.loadrssicon(mc[clipname]["icon"], rssicon)) {
			worldkitUtil.setTimeout(this, "loadrssicon", 1000);
		}
	    }
	    public function activateicon(time:Number) {
		if (mc[clipname]["icon"] == undefined) {
			return;
		}
		var iconwidth;
		var alpha = 100;
		if (time == 2) {
			iconwidth = conf.rssiconwidth;
			alpha = curralpha;
		} else if (time == 3) {
			iconwidth = conf.rssiconwidth * 1.5;
		}
		img.activateicon(mc[clipname]["icon"], rssicon, iconwidth);
		mc[clipname]["icon"].alpha = alpha;
	   }
	
	    //REVISIT 
	    protected function tracks():void {
		if (conf.track && prevx != undefined && prevy != undefined) {
		    var layer;
		    if (conf.trackcats) {
			if (mc.tracks[ cats[0] ] == undefined) {
			    mc.tracks.createEmptyMovieClip( cats[0], mc.tracks.tracklayer );
			    mc.tracks.tracklayer++;
			}
			layer = mc.tracks[ cats[0] ];
	
		    } else {
			layer = mc;
		    }
		    
		    layer.graphics.lineStyle( linethickness, linecolor, linealpha );
		    layer.graphics.moveTo(mc[clipname].x, mc[clipname].y);
		    layer.graphics.lineTo(prevx,prevy);
		}
		//rss.setTrackVis();
		//	worldkitAnnotationClass.setTrackVis(this.conf, this.datalayer);
	    }
	
	
	    protected function buildJsArgs():String {
		return "link=" + escape(url) + "&lat=" + escape(String(lat)) + "&long=" + escape(String(lon)) + "&id=" + escape(id);
	    }
	
	    public function setLoc():void {
		var a = interact.geo2xy(lat, lon, true);
		x = a[0]; y = a[1];
		if (x == undefined || y == undefined) { return; }
		mc[clipname].x = x; mc[clipname].y = y;
		mc[textname].x = x; mc[textname].y = y;
	    }
	
	    public function setVisible(forcetext:Boolean, textvis:Number):void {
		//accurate -- might also just call this, or make another function for repositioning
		var visible = true;
	    
		for (var s in cats) {
		    if (conf.categories[ cats[s] ] == false) {
			visible = false;
		    }
		}
	    
		if (conf.timenav != false) {
		    if (conf.neartime) {
			if (Math.abs(interact.maxtime - date) > conf.neartime) {
			    visible = false;
			}
		    } else {
			if (enddate != undefined) {
			    if (enddate < interact.maxtime) {
				visible = false;
			    }
			}
			if (date > interact.maxtime) {
			    visible = false;
			}
		    }
		}
		
		if (visible) {
		    if (mc[clipname].visible == 0 || forcetext) {
			mc[clipname].visible = 1;
			if (textvis > 0) {
			    mc[textname].visible = 1;
			    worldkitUtil.setTimeout(this,"hidetext",textvis);
			}
		    }
		} else {
		    mc[clipname].visible = 0;
		    mc[textname].visible = 0;
		}
	    }
	
	    public function setActivate(cat:String):void {
		var hit = false;
		for (var s in cats) {
		    if (cats[s] == cat) {
			hit = true;
		    }
		}
		
		if (hit) {
		    if (activate == true) {
			activate = false;
			shape(2);
		    } else {
			activate = true;
			shape(3);
		    }
		}
	    }
	    public function forceActivate():void {
		if (activate == true) {
			activate = false;
			shape(2);
		} else {
			activate = true;
			shape(3);
		}
	    }
	
	    public function setAlphaFade(now:Date):void {
		if (curralpha == -1) { return; }
		var s = (now - createdate) / 1000;
		var clip;
		if (mc[clipname]["icon"]) {
			clip = mc[clipname]["icon"];
		} else {
			clip = mc[clipname];
		}
		clip.alpha = 100 - 100 * (s / conf.fade);
		curralpha = clip.alpha;
	
		if (curralpha <= 0) {
			if (mc[clipname]["icon"]) {
				mc[clipname]["icon"].removeMovieClip();
				mc[clipname]["icon"] = 1;
			} else {
				mc[clipname].graphics.clear();
			}
			if (conf.fadeditemcallback) {
			    	var msg = "&id=" + escape(id);	
		    	    	interact.processClick("", "_" + conf.fadeditemcallback, msg);
			}	
			curralpha = -1;
		}	
	    }
	
	    public function hidetext():void {
		if (conf.singletextfield != true) {
		    mc[textname].visible = 0;
		} else {
		    interact.LoadingDialog(undefined, true);
		}
	    }
	
	    public function showtext(setActive:Boolean):void {
		if (conf.singletextfield != true) {
		    if (setActive) {
		    	rss.setActive(this);
		    }
	
		    var ratio = conf.w / conf.h;
		    var stagew, stageh, textx, texty;
		    if (ratio > 1) { stagew  = 100 * ratio; stageh = 100; }
		    else { stageh = 100 / ratio; stagew = 100; }
	
		    var mousex = conf.w * (_root.mouseX / stagew);
		    var mousey = conf.h * (_root.mouseY / stageh);
	
		    if (mc.origwidth - mousex < conf.textboxsize) { textx = mousex - (conf.textboxsize / interact.scale); }
	            if (mc.origheight - y < 100) { texty = mousey - (50 / interact.scale); }   
	
	            mc[ textname ].x = textx; if (textx != x) { mc[textname].leftpos = true; }
	            mc[ textname ].y = texty; if (texty != y) { mc[textname].bottompos = true; }
	
		    mc[ textname ].visible = 1; 
		} else {
		    interact.LoadingDialog( title, true, 10);
		}
	    }
	
	    public function onRollOver():void {
		showtext(true);
	    }
	    public function onRollOut():void {
		worldkitUtil.setTimeout(this,"hidetext",conf.visinterval); 
	    }
	    public function onRelease():void {
		if (zoomto != undefined) {
		    interact.zoomTo(lat, lon, zoomto);
		} else {
		    interact.cautiousProcessClick(url,window,jsargs); 
		}
	    }
	    public function onReleaseText():void {
		if (zoomto != undefined) {
		    interact.zoomTo(lat, lon, zoomto);
		} else {
		    interact.cautiousProcessClick(url,window,jsargs+"&text=1"); 
		}
	    }
	
	    public function graphics.clear():void {
		mc[clipname].removeMovieClip();
		mc[textname].removeMovieClip();
	    }
	
	    public function changed(title:String, url:String, lat:Number, lon:Number, summary:String, cats:Array, photo:String, vector:String, vtype:String, datestring:String):Boolean {
		var changed = false;
		if (title != this.title) { this.title = title; changed = true; }
		if (url != this.url) { this.url = url; changed = true; }
		if (lat != this.lat) { this.lat = lat; changed = true; }
		if (lon != this.lon) { this.lon = lon; changed = true; }
		if (summary != this.summary) { this.summary = summary; changed = true; }
		if (cats.join(':') != this.cats.join(':')) { this.cats = cats; changed = true; }
		if (photo != this.photo) { this.photo = photo; changed = true; }
		if (vector != this.vector) { this.vector = vector; changed = true; }
		if (vtype != this.vtype) { this.vtype = vtype; changed = true; }
		if (datestring != this.datestring) {this.date = new Date(worldkitUtil.parseDate(datestring)); changed = true; } //REVISIT work??
		
		return changed;
	    }
	
	    /*
	      REVISIT -- what's the purpose of this
	    */
	    public function clearMC():void {
		if (precompile != true) {
		    mc[ clipname ].graphics.clear();
		    mc[ textname ].removeMovieClip();
		}
	    }
	
	    public function GetItem():void {
		var s = "||";
		var catstring = cats.join(",");
		var coords;
		if (vtype == "poly" || vtype == "line") {
		    coords = vector;
		} else {
		    coords = String(lat) + "," + String(lon);
		}
		var args = title + s + url + s + summary + s + catstring + s + coords + s + vtype;
		interact.annotate(null,null,args);
	    }
	}
	
}