package com.brainoff { 
	/*
	  worldkitGPX classes transparently manages all worldkitGPX instances
	    slightly different tact from other worldkit classes, works well, perhaps a model later on
	*/
	
	
	import flash.display.MovieClip;
	import flash.xml.XMLDocument;
	import flash.xml.XMLNode;
	public class worldkitGPX {
	    static protected var _instances:Array;
	
	    protected var main:worldkitMain;
	    protected var conf:worldkitConfig;
	    protected var img:worldkitImages;
	    protected var interact:worldkitInteraction;
	
	    protected var mcparent:MovieClip;
	    protected var mcid:String;
	    protected var level:Number;
	    protected var url:String;
	    protected var cats:Array;
	
	    public static function start(main:worldkitMain) {
		var conf:worldkitConfig = main.getConfig();
		
		var layer = worldkitImages.nextLayer();
		var mc = worldkitImages.getmc();
	    	for (var s in conf.gpx) {
		    new worldkitGPX(main, mc, s, layer, conf.gpx[s].url, conf.gpx[s].cats);
		}
	    }
	    public static function Pan() {
		for (var g in _instances) {
		    _instances[g].PanInstance();
		}
	    }
	
	    public function worldkitGPX(main:worldkitMain, mcparent:MovieClip, mcid:String, level:Number, url:String, cats:String) {
		if (_instances == undefined) {
		    _instances = new Array();
		}
		_instances.push(this);
		
		this.main = main;
		this.conf = main.getConfig();
		this.img = main.getImages();
		this.interact = main.getInteract();
		this.mcparent = mcparent;
		this.mcid = mcid;
		this.level = level;
		this.url = url;
		if (cats != undefined) {
		    this.cats = cats.split(",");
		} else {
		    this.cats = new Array();
		}
		this.cats.push("_default_");
	
		
		this.mcparent.createEmptyMovieClip(this.mcid, this.level);
		this.mcparent[this.mcid].origwidth = this.conf.w;
		this.mcparent[this.mcid].origheight = this.conf.h;
	
		load();
	    }
	
	    protected function unscale() {
		mcparent[ this.mcid ].x = 0; mcparent[ this.mcid ].y = 0; mcparent[ this.mcid ].scaleX = 100; mcparent[ this.mcid ].scaleY = 100; mcparent[ this.mcid ].visible = 0;
	    }
	
	    protected function load() {
		var gpx:worldkitGPX = this;
		var loader:XMLDocument = new XMLDocument();
		loader.ignoreWhite = true;
		loader.onLoad = function(success) { gpx.onLoad(this, success); }
		loader.load(url);
	    }
	
	    public function onLoad(xml:XMLDocument, success:Boolean):void {
		if (! success) { return; }
	
		unscale();
		
		for (var i = 0; i < xml.childNodes.length; i++) {
		    if (xml.childNodes[i].nodeName == "gpx") {
			for (var j = 0; j < xml.childNodes[i].childNodes.length; j++) {
			    if (xml.childNodes[i].childNodes[j].nodeName == "trk") {
				parseTrack(xml.childNodes[i].childNodes[j]);
			    }
			}
			
		    }
		}
		
		interact.scaleAndPosition(mcparent,mcid);
		mcparent[ mcid ].visible = 1;
	    }
	
	    protected function parseTrack(node:XMLNode):void {
		var coordinates = new Array(); 
		var c;
		for (var i = 0; i < node.childNodes.length; i++) {
		    if (node.childNodes[i].nodeName == "trkseg") {
			for (var j = 0; j < node.childNodes[i].childNodes.length; j++) {
			    if (node.childNodes[i].childNodes[j].nodeName == "trkpt") {
				c = node.childNodes[i].childNodes[j].attributes.lat + "," + node.childNodes[i].childNodes[j].attributes.lon;
				coordinates.push(c);
			    }
			}
		    }
		}
		plotLine(coordinates);
	    }
	
	    protected function plotLine(coordinates:Array):void {
		var linecolor:Number = conf.getConfBySubject("linecolor",cats);
		var linealpha:Number = conf.getConfBySubject("linealpha",cats);
		var linethickness:Number = conf.getConfBySubject("linethickness",cats);
		
		mcparent[ mcid ].graphics.lineStyle(linethickness, linecolor, linealpha);
		for (var i = 0; i < coordinates.length; i++) {
		    if (coordinates[i].indexOf(",") != -1) {
			var latlon = coordinates[i].split(",");
			var xy = interact.geo2xy(latlon[0], latlon[1]);
			if (i == 0) {
			    mcparent[ mcid ].graphics.moveTo(xy[0],xy[1]);
			} else {
			    mcparent[ mcid ].graphics.lineTo(xy[0],xy[1]);
			}
		    }
		}
	    }
	
	    protected function PanInstance():void {
		interact.scaleAndPosition(mcparent, mcid);
	    }
	}
	   
	
}